<template>
    <div class="form-editor" v-if="display">
        <FormSelector v-if="displayFormSelector" />
        <FormDisplay
            v-if="!displayFormSelector"
            :report="loadReport"
            :entity="loadEntity"
        />
    </div>
</template>

<script lang="ts">
import { Options, Vue } from 'vue-class-component';
import FormSelector from '@/components/FormSelector.vue';
import FormDisplay from '@/components/FormDisplay.vue';
import app from '../main';

@Options({
    components: {
        FormSelector,
        FormDisplay,
    },
})
export default class FormEditorView extends Vue {
    displayFormSelector = true;
    loadReport = '';
    loadEntity = '';

    get display() {
        return !app.config.globalProperties.routerLoad;
    }

    mounted() {
        this.getReportParams();

        this.$watch(
            () => this.$route.query,
            () => {
                this.getReportParams();
            }
        );
    }

    getReportParams() {
        if (this.$route.query.report != null) {
            this.displayFormSelector = false;
            this.loadReport = this.$route.query.report as string;
        } else {
            this.displayFormSelector = true;
        }

        if (
            this.$route.query.entity != null &&
            this.$route.query.report != null
        ) {
            this.loadEntity = this.$route.query.entity as string;
        }
    }
}
</script>
